dofile_once( "mods/p2k/files/scripts/generic_lib.lua" )
dofile_once( "mods/p2k/files/scripts/window_lib.lua" )
dofile_once( "mods/p2ke_magic_numbers/files/magic_numbers_lib.lua" )

function create_magic_numbers_window( loc, pic_z )
	local wnd = {
		title = "MAGIC_NUMBERS",
		style = "big_B",
		minimized = false,
		parent = 0,
		children = {},
		w_x = loc[1],
		w_y = loc[2],
		w_z = pic_z,
		extra = {
			contents = magic_numbers_window,
			page = 1,
		},
	}
	
	local id = new_number()
	add_window( wnd, id )
	
	return id
end

function magic_numbers_window( gui, uid, pic_x, pic_y, pic_z, wid )
	local raw_numbers = ModSettingGetNextValue( "p2ke_magic_numbers.MAGIC_NUMBERS" )
	if( raw_numbers == "<>" ) then
		pic_x = pic_x + 2
		pic_y = pic_y + 11
		new_text( gui, pic_x, pic_y, pic_z, "[REBOOT THE GAME]", 2 )
		return uid
	end

	local pic, clicked, r_clicked, color = 0, 0, 0
	local t_x, t_y = pic_x, pic_y
	
	local page = window_table[dimension][wid].extra.page
	normal_numbers = normal_numbers or magic_extractor( D_extractor( raw_numbers ))
	
	t_x = t_x + 2
	local updater = false
	local starter = 9*page - 8
	local ender = 9*page
	for i = starter,ender do
		if( i > #normal_numbers ) then
			break
		end
		
		t_y = t_y + 11
		local fancy_text = normal_numbers[i][1]
		new_text( gui, t_x, t_y, pic_z, liner( gui, fancy_text, 68 ), 2 )
		uid = new_tooltip( gui, uid, ui_z - 200, fancy_text )
		
		uid, r_clicked = new_input( gui, uid, t_x + 70, t_y, pic_z, 60, wid..tostring( fancy_text ), normal_numbers[i][2] )
		if( r_clicked ) then
			play_sound( "confirm" )
			if( normal_numbers[i][2] ~= keyboard_info[dimension][2]..keyboard_info[dimension][3] ) then
				normal_numbers[i][2] = keyboard_info[dimension][2]..keyboard_info[dimension][3]
				updater = true
			end
			keyboard_info[dimension] = { "", "<>", "" }
		end
	end
	
	if( updater ) then
		ModSettingSetNextValue( "p2ke_magic_numbers.MAGIC_NUMBERS", D_packer( magic_packer( normal_numbers )), false )
	end
	
	pic_x = pic_x + 136
	pic_y = pic_y + 11
	pic = "mods/p2k/files/pics/button_21_A.png"
	uid, clicked, r_clicked = new_button( gui, uid, pic_x, pic_y, pic_z, pic )
	new_text( gui, pic_x + 2, pic_y, pic_z - 0.01, "DFT" )
	uid = new_tooltip( gui, uid, ui_z - 200, "", "RMB to set to default.", true )
	if( r_clicked ) then
		play_sound( "delete" )
		ModSettingSetNextValue( "p2ke_magic_numbers.MAGIC_NUMBERS", "<>", false )
	end
	
	pic_y = pic_y + 77
	uid, page = new_pager( gui, uid, pic_x, pic_y, pic_z, page, math.ceil( #normal_numbers/9 ))
	if( page ~= window_table[dimension][wid].extra.page ) then
		window_table[dimension][wid].extra.page = page
	end
	
	return uid
end