dofile( "data/scripts/lib/mod_settings.lua" )

function mod_setting_reseter( mod_id, gui, in_main_menu, im_id, setting )
	local value = ModSettingGetNextValue( mod_setting_get_id( mod_id, setting ))
	local text = setting.ui_name .. " - " ..( value and "[ARMED] (RMB to cancel)" or "[STANDING BY] (LMB to arm)" )
	
	local clicked, r_clicked = GuiButton( gui, im_id, mod_setting_group_x_offset, 0, text )
	if clicked then
		if( value ) then
			ModSettingSetNextValue( mod_setting_get_id( mod_id, setting ), not value, false )
			ModSettingSetNextValue( "p2ke_magic_numbers.MAGIC_NUMBERS", "<>", false )
		else
			ModSettingSetNextValue( mod_setting_get_id( mod_id, setting ), not value, false )
		end
	elseif( r_clicked ) then
		ModSettingSetNextValue( mod_setting_get_id( mod_id, setting ), false, false )
	end
	
	mod_setting_tooltip( mod_id, gui, in_main_menu, setting )
end

function mod_setting_change_callback( mod_id, gui, in_main_menu, setting, old_value, new_value  )
	ModSettingSetNextValue( "p2ke_magic_numbers.MAGIC_NUMBERS", "<>", false )
end

local mod_id = "p2ke_magic_numbers"
mod_settings_version = 1
mod_settings = 
{
	{
		id = "REALLY_CHANGE",
		ui_name = "Always overwrite",
		ui_description = "",
		value_default = true,
		scope = MOD_SETTING_SCOPE_NEW_GAME,
	},

	{
		id = "USE_CUSTOM",
		ui_name = "Overwrite the vanilla",
		ui_description = "",
		value_default = true,
		scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	
	{
		id = "ADVANCED",
		ui_name = "Use full list",
		ui_description = "Changing this will reset your current magic setup.",
		value_default = false,
		scope = MOD_SETTING_SCOPE_NEW_GAME,
		change_fn = mod_setting_change_callback,
	},
	
	{
		id = "RESETER",
		ui_name = "Set to default",
		ui_description = "",
		value_default = false,
		scope = MOD_SETTING_SCOPE_RUNTIME,
		ui_fn = mod_setting_reseter,
	},
	
	{
		id = "MAGIC_NUMBERS",
		ui_name = "Magic Numbers",
		ui_description = "",
		hidden = true,
		value_default = "<>",
		text_max_length = 100000,
		scope = MOD_SETTING_SCOPE_RUNTIME,
	},
}

function ModSettingsUpdate( init_scope )
	local old_version = mod_settings_get_version( mod_id )
	mod_settings_update(mod_id, mod_settings, init_scope)
end

function ModSettingsGuiCount()
	return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
	mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end